import { isDevMode, Component, Inject, Input, EventEmitter, Output, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { MatDialogRef, MAT_DIALOG_DATA, MatDialogModule } from '@angular/material/dialog';
import { __extends } from 'tslib';
import { TranslateService, TranslateModule } from '@ngx-translate/core';
import { FormBuilder, ReactiveFormsModule } from '@angular/forms';
import { distinctUntilChanged, debounceTime } from 'rxjs/operators';
import { MatFormFieldModule } from '@angular/material/form-field';
import { MatTooltipModule } from '@angular/material/tooltip';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ErrorDialog = /** @class */ (function () {
    function ErrorDialog(dialogRef, data) {
        this.dialogRef = dialogRef;
        this.data = data;
    }
    /**
     * @return {?}
     */
    ErrorDialog.prototype.onNoClick = /**
     * @return {?}
     */
    function () {
        this.dialogRef.close();
    };
    /**
     * @param {?} e
     * @param {?=} data
     * @return {?}
     */
    ErrorDialog.extractErrorInfo = /**
     * @param {?} e
     * @param {?=} data
     * @return {?}
     */
    function (e, data) {
        if (data === void 0) { data = {}; }
        return Object.assign(data, {
            showDetails: isDevMode(),
            message: e.message
        });
    };
    /**
     * show error popup if needed
     * @param dialog dialog factory
     * @param e error
     * @param opts
     */
    /**
     * show error popup if needed
     * @param {?} dialog dialog factory
     * @param {?} e error
     * @param {?=} opts
     * @return {?}
     */
    ErrorDialog.openErrorDialog = /**
     * show error popup if needed
     * @param {?} dialog dialog factory
     * @param {?} e error
     * @param {?=} opts
     * @return {?}
     */
    function (dialog, e, opts) {
        if (opts === void 0) { opts = {}; }
        /** @type {?} */
        var config = Object.assign({
            canBeClosed: true,
            closeOnNavigation: true,
            panelClass: 'dialog-layout',
            disableClose: false,
        }, opts);
        config.data = ErrorDialog.extractErrorInfo(e, config.data);
        console.log('openErrorDialog: ', config);
        /** @type {?} */
        var dialogRef = dialog.open(ErrorDialog, config);
        dialogRef.disableClose = false;
        dialogRef.afterClosed().subscribe((/**
         * @param {?} result
         * @return {?}
         */
        function (result) {
            console.log('The dialog was closed', result);
        }));
        console.log(e);
        return dialogRef;
    };
    ErrorDialog.decorators = [
        { type: Component, args: [{
                    selector: 'base-error-dialog',
                    template: "<h2>ERROR</h2>\n<p>{{data.message}}</p>\n<mat-dialog-content>\n\n  <div class=\"error-info\">\n    <table class=\"info-grid\">\n      <tbody>\n      <tr *ngIf=\"data.status\"><td class=\"label\">Status</td><td class=\"val\">{{data.status}}</td></tr>\n      <tr *ngIf=\"data.code\"><td class=\"label\">Code</td><td class=\"val\">{{data.code}}</td></tr>\n      <tr *ngIf=\"data.link\"><td class=\"label\">Link</td><td class=\"val\">{{data.link}}</td></tr>\n      <tr *ngIf=\"data.request\"><td class=\"label\">Request</td><td class=\"val\">{{data.request}}</td></tr>\n      <tr *ngIf=\"data.operation\"><td class=\"label\">Operation</td><td class=\"val\">{{data.operation}}</td></tr>\n      <tr *ngIf=\"data.component\"><td class=\"label\">Component</td><td class=\"val\">{{data.component}}</td></tr>\n      <tr *ngIf=\"data.developerMessage\"><td class=\"label\">Dev Message:</td><td class=\"val\">{{data.developerMessage}}</td></tr>\n      </tbody>\n    </table>\n  </div>\n\n</mat-dialog-content>\n\n<mat-dialog-actions>\n    <button type=\"button\" class=\"cmd\" matDialogClose mat-raised-button color=\"primary\">Close</button>\n</mat-dialog-actions>\n"
                }] }
    ];
    /** @nocollapse */
    ErrorDialog.ctorParameters = function () { return [
        { type: MatDialogRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
    ]; };
    return ErrorDialog;
}());
if (false) {
    /** @type {?} */
    ErrorDialog.prototype.dialogRef;
    /** @type {?} */
    ErrorDialog.prototype.data;
}
var ErrorDialogHandler = /** @class */ (function () {
    function ErrorDialogHandler(dialog) {
        this.dialog = dialog;
    }
    /**
     * @param {?} error
     * @return {?}
     */
    ErrorDialogHandler.prototype.handleError = /**
     * @param {?} error
     * @return {?}
     */
    function (error) {
        console.warn("ErrorDialogHandler handleError:", error);
        ErrorDialog.openErrorDialog(this.dialog, error);
    };
    return ErrorDialogHandler;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    ErrorDialogHandler.prototype.dialog;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ObjectNotFoundDialogComponent = /** @class */ (function (_super) {
    __extends(ObjectNotFoundDialogComponent, _super);
    function ObjectNotFoundDialogComponent(dialogRef, data) {
        var _this = _super.call(this, dialogRef, data) || this;
        _this.dialogRef = dialogRef;
        _this.data = data;
        return _this;
    }
    /**
     * @return {?}
     */
    ObjectNotFoundDialogComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    /**
     * @param {?} dialog
     * @param {?} e
     * @param {?=} opts
     * @return {?}
     */
    ObjectNotFoundDialogComponent.openObjectNotFoundDialog = /**
     * @param {?} dialog
     * @param {?} e
     * @param {?=} opts
     * @return {?}
     */
    function (dialog, e, opts) {
        if (opts === void 0) { opts = {}; }
        /** @type {?} */
        var config = Object.assign({
            canBeClosed: true,
            closeOnNavigation: true,
            panelClass: 'dialog-layout',
            disableClose: false,
        }, opts);
        config.data = ObjectNotFoundDialogComponent.extractErrorInfo(e, config.data);
        console.log('openErrorDialog: ', config);
        /** @type {?} */
        var dialogRef = dialog.open(ObjectNotFoundDialogComponent, config);
        dialogRef.disableClose = false;
        return dialogRef;
    };
    ObjectNotFoundDialogComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-object-not-found-dialog',
                    template: "<h2>OBJECT NOT FOUND</h2>\n<p>{{data.message}}</p>\n<mat-dialog-content>\n\n  <div class=\"error-info\">\n    <table class=\"info-grid\">\n      <tbody>\n      <tr *ngIf=\"data.status\"><td class=\"label\">Status</td><td class=\"val\">{{data.status}}</td></tr>\n      <tr *ngIf=\"data.code\"><td class=\"label\">Code</td><td class=\"val\">{{data.code}}</td></tr>\n      <tr *ngIf=\"data.link\"><td class=\"label\">Link</td><td class=\"val\">{{data.link}}</td></tr>\n      <tr *ngIf=\"data.request\"><td class=\"label\">Request</td><td class=\"val\">{{data.request}}</td></tr>\n      <tr *ngIf=\"data.operation\"><td class=\"label\">Operation</td><td class=\"val\">{{data.operation}}</td></tr>\n      <tr *ngIf=\"data.component\"><td class=\"label\">Component</td><td class=\"val\">{{data.component}}</td></tr>\n      <tr *ngIf=\"data.developerMessage\"><td class=\"label\">Dev Message:</td><td class=\"val\">{{data.developerMessage}}</td></tr>\n      </tbody>\n    </table>\n  </div>\n\n</mat-dialog-content>\n\n<mat-dialog-actions>\n  <button mat-raised-button type=\"button\" color=\"accent\" [mat-dialog-close]=\"true\">{{ 'CMD.delete' | translate }}</button>\n  <button mat-button type=\"button\" [mat-dialog-close]=\"false\">{{ 'CMD.cancel' | translate }}</button>\n</mat-dialog-actions>\n"
                }] }
    ];
    /** @nocollapse */
    ObjectNotFoundDialogComponent.ctorParameters = function () { return [
        { type: MatDialogRef },
        { type: undefined, decorators: [{ type: Inject, args: [MAT_DIALOG_DATA,] }] }
    ]; };
    return ObjectNotFoundDialogComponent;
}(ErrorDialog));
if (false) {
    /** @type {?} */
    ObjectNotFoundDialogComponent.prototype.dialogRef;
    /** @type {?} */
    ObjectNotFoundDialogComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BaseDateComponent = /** @class */ (function () {
    function BaseDateComponent(translate) {
        this.translate = translate;
        this.format = 'day';
        this.formatTip = 'date';
    }
    /**
     * @return {?}
     */
    BaseDateComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.translate != null) {
            this.format = this.translatePattern(this.format, 'yyyy-MM-dd');
            if ('false' !== this.formatTip) {
                this.formatTip = this.translatePattern(this.formatTip, 'yyyy-MM-dd HH:mm:ss Z');
            }
        }
    };
    /**
     * @param {?} key
     * @param {?} fallback
     * @return {?}
     */
    BaseDateComponent.prototype.translatePattern = /**
     * @param {?} key
     * @param {?} fallback
     * @return {?}
     */
    function (key, fallback) {
        /** @type {?} */
        var value = fallback;
        if (BaseDateComponent.FORMAT_NAMES.indexOf(key) !== -1) {
            this.translate.get(BaseDateComponent.RES_PREFIX + key).subscribe((/**
             * @param {?} result
             * @return {?}
             */
            function (result) {
                value = result;
            }));
        }
        return value;
    };
    BaseDateComponent.RES_PREFIX = 'DateFormat.';
    BaseDateComponent.FORMAT_NAMES = ['day', 'date', 'full', 'time', 'year'];
    BaseDateComponent.decorators = [
        { type: Component, args: [{
                    selector: 'base-date',
                    template: "<span *ngIf=\"data\"\n      [matTooltip]=\"formatTip != 'false' ? (data|date:formatTip) : null\">{{data|date:format}}</span>\n"
                }] }
    ];
    /** @nocollapse */
    BaseDateComponent.ctorParameters = function () { return [
        { type: TranslateService }
    ]; };
    BaseDateComponent.propDecorators = {
        data: [{ type: Input }],
        format: [{ type: Input }],
        formatTip: [{ type: Input }]
    };
    return BaseDateComponent;
}());
if (false) {
    /** @type {?} */
    BaseDateComponent.RES_PREFIX;
    /** @type {?} */
    BaseDateComponent.FORMAT_NAMES;
    /** @type {?} */
    BaseDateComponent.prototype.data;
    /** @type {?} */
    BaseDateComponent.prototype.format;
    /** @type {?} */
    BaseDateComponent.prototype.formatTip;
    /**
     * @type {?}
     * @protected
     */
    BaseDateComponent.prototype.translate;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var BaseChangeComponent = /** @class */ (function () {
    function BaseChangeComponent() {
    }
    /**
     * @return {?}
     */
    BaseChangeComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
    };
    BaseChangeComponent.decorators = [
        { type: Component, args: [{
                    selector: 'base-change',
                    template: "<!--<base-date [data]=\"data?.date\"></base-date>-->\n"
                }] }
    ];
    /** @nocollapse */
    BaseChangeComponent.ctorParameters = function () { return []; };
    BaseChangeComponent.propDecorators = {
        data: [{ type: Input }]
    };
    return BaseChangeComponent;
}());
if (false) {
    /** @type {?} */
    BaseChangeComponent.prototype.data;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var TableSearchComponent = /** @class */ (function () {
    function TableSearchComponent(fb) {
        this.fb = fb;
        this.changed = new EventEmitter();
        this.debounceTime = 700;
        this.suffix = '*';
    }
    /**
     * @return {?}
     */
    TableSearchComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.formGroup = this.fb.group({
            keyword: [null, null]
        });
        this.formGroup.valueChanges.pipe(distinctUntilChanged(), debounceTime(this.debounceTime)).subscribe((/**
         * @param {?} val
         * @return {?}
         */
        function (val) {
            if (!(val.keyword === null)) {
                val.keyword = val.keyword + _this.suffix;
            }
            _this.changed.emit(val);
        }));
    };
    TableSearchComponent.decorators = [
        { type: Component, args: [{
                    selector: 'table-search',
                    template: "<form [formGroup]=\"formGroup\">\n  <mat-form-field>\n    <mat-label>Suchen</mat-label>\n    <input matInput formControlName=\"keyword\" type=\"search\" nullValue/>\n  </mat-form-field>\n</form>"
                }] }
    ];
    /** @nocollapse */
    TableSearchComponent.ctorParameters = function () { return [
        { type: FormBuilder }
    ]; };
    TableSearchComponent.propDecorators = {
        changed: [{ type: Output }]
    };
    return TableSearchComponent;
}());
if (false) {
    /** @type {?} */
    TableSearchComponent.prototype.changed;
    /** @type {?} */
    TableSearchComponent.prototype.formGroup;
    /** @type {?} */
    TableSearchComponent.prototype.debounceTime;
    /** @type {?} */
    TableSearchComponent.prototype.suffix;
    /**
     * @type {?}
     * @private
     */
    TableSearchComponent.prototype.fb;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var ChainBaseComp = /** @class */ (function () {
    function ChainBaseComp() {
    }
    ChainBaseComp.decorators = [
        { type: NgModule, args: [{
                    declarations: [
                        ErrorDialog,
                        ObjectNotFoundDialogComponent,
                        TableSearchComponent,
                        BaseChangeComponent,
                        BaseDateComponent
                    ],
                    imports: [
                        ReactiveFormsModule,
                        MatFormFieldModule,
                        MatTooltipModule,
                        CommonModule,
                        MatDialogModule,
                        TranslateModule
                    ],
                    exports: [
                        ErrorDialog,
                        ObjectNotFoundDialogComponent,
                        TableSearchComponent,
                        BaseChangeComponent,
                        BaseDateComponent
                    ],
                    entryComponents: [
                        ObjectNotFoundDialogComponent,
                        //ValidationResultDialogComponent,
                        ErrorDialog
                    ],
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                },] }
    ];
    return ChainBaseComp;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { BaseChangeComponent, BaseDateComponent, ChainBaseComp, ErrorDialog, ErrorDialogHandler, ObjectNotFoundDialogComponent, TableSearchComponent };
//# sourceMappingURL=yukawa-chain-base-angular-comp.js.map
